<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Cuenta palabras y caracteres</title>
	<script type="text/javascript" src="tiny_mce/tiny_mce.js"></script>
	<script type="text/javascript">
		tinyMCE.init({
			mode : "textareas",
			theme : "advanced",
			language : "es",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,formatselect,bullist,numlist,outdent,indent",
			theme_advanced_buttons2 : "link,unlink,anchor,image,|,undo,redo,cleanup,code,|,sub,sup,charmap",
			theme_advanced_buttons3 : "",
			height : "200px",
			width : "600px"
		});
		function cuenta(id) {
			var objeto = tinymce.get(id);
			var body = objeto.getBody();
			var text = tinymce.trim(body.innerText || body.textContent);
			return {
				chars: text.length,
				words: (text.split(/[\w\u2019\'-]+/).length) - 1
			};
		}
		function muestraDatos(id){
			cadena = "Caracteres: " + cuenta(id).chars;
			cadena += "\nPalabras: " + cuenta(id).words;
			alert (cadena);
		}
	</script>
</head>
<body>
	<form method="post" action="mostrar_texto.php">
		<textarea id="texto" name="texto"></textarea>
		<br />
		<input type="button" value="Contar" onClick="javascript:muestraDatos('texto');" />
	</form>
</body>
</html>
