var nombreDeCampo;
function mostrarCapaDeColores(campo){
	nombreDeCampo = campo;
	visibilidad = document.getElementById("capaDeSelectorDeColor").style.visibility;
	if (visibilidad == "visible"){
		document.getElementById("capaDeSelectorDeColor").style.visibility = "hidden";
	} else {
		document.getElementById("capaDeSelectorDeColor").style.visibility = "visible";
	}
	ponerPaleta();
}
function ponerPaleta(){
	paleta = document.getElementById("selectorDePaleta").value;
	switch (paleta){
	case "0":
		tablaDeColores = generarColoresWeb();
		break;
	case "1":
		tablaDeColores = generarColoresWindows();
		break;
	case "2":
		tablaDeColores = generarEscalaDeGrises();
		break;
	case "3":
		tablaDeColores = generarColoresMac();
		break;
	}
	document.getElementById("tablaDeColores").innerHTML = tablaDeColores;
}
function generarColoresWeb() {
	var s = '';
	for (j = 0; j < 12; j ++) {
		s += "<tr>";
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i ++)
				s += crearCelda(k * 51 + (j % 2) * 51 * 3, Math.floor(j / 2) * 51, i * 51);
		s += "</tr>";
	}
	return s;
}

function generarColoresWindows() {
	var s = '';
	for (j = 0; j < 12; j ++) {
		s += "<tr>";
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i++)
				s += crearCelda(i * 51, k * 51 + (j % 2) * 51 * 3, Math.floor(j / 2) * 51);
		s += "</tr>";
	}
	return s	
}
function generarEscalaDeGrises() {
	var s = '';
	for (j = 0; j <= 15; j ++) {
		s += "<tr>";
		for (k = 0; k <= 15; k ++) {
			g = Math.floor((k + j * 16) % 256);
			s += crearCelda(g, g, g);
		}
		s += '</tr>';
	}
	return s
}
function generarColoresMac() {
	var s = '';
	var c = 0,n = 1;
	var r,g,b;
	for (j = 0; j < 15; j ++) {
		s += "<tr>";
		for (k = 0; k < 3; k ++)
			for (i = 0; i <= 5; i++){
				if(j<12){
				s += crearCelda(255-(Math.floor(j / 2) * 51), 255-(k * 51 + (j % 2) * 51 * 3),255-(i * 51));
				}else{
					if(n<=14){
						r = 255-(n * 17);
						g=b=0;
					}else if(n>14 && n<=28){
						g = 255-((n-14) * 17);
						r=b=0;
					}else if(n>28 && n<=42){
						b = 255-((n-28) * 17);
						r=g=0;
					}else{
						r=g=b=255-((n-42) * 17);
					}
					s += crearCelda(r, g, b);
					n++;
				}
			}
		s += "</tr>";
	}
	return s;
}
function crearCelda (R, G, B) {
	fondo = dec2hex(R, G, B);
	celda = "<td bgColor=" + fondo +">";
	celda += "<img src=\"img/pixel.gif\" border=\"0\" width=\"10\" height=\"10\" id=\""+fondo+"\" onMouseOver=\"javascript:ponerCodigo(this.id)\" onMouseOut=\"javascript:ponerCodigo('');\" onClick=\"javascript:seleccionarColor(this.id);\" />";
	celda += "</td>";
	return celda;
}
function dec2hex(R, G, B){
	rH = (R<16)?"0"+R.toString(16).toUpperCase():R.toString(16).toUpperCase();
	gH = (G<16)?"0"+G.toString(16).toUpperCase():G.toString(16).toUpperCase();
	bH = (B<16)?"0"+B.toString(16).toUpperCase():B.toString(16).toUpperCase();
	color = "#"+rH+gH+bH;
	return color;
}
function ponerCodigo(fondo){
	document.getElementById("capaDeCodigo").innerHTML = fondo;
}
function seleccionarColor(color){
	document.getElementById(nombreDeCampo).value = color;
	document.getElementById("capaDeSelectorDeColor").style.visibility = "hidden";
}

