-- phpMyAdmin SQL Dump
-- version 2.11.6
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generacin: 17-05-2009 a las 07:09:57
-- Versin del servidor: 5.0.51
-- Versin de PHP: 5.2.6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Base de datos: 'categorias'
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla 'categorias'
--

DROP TABLE IF EXISTS categorias;
CREATE TABLE IF NOT EXISTS categorias (
  id_de_categoria int(11) NOT NULL auto_increment COMMENT 'El id de la categora, que se emplear para las relaciones jerrquicas.',
  tipo_de_contenido varchar(255) default NULL COMMENT 'Permite establecer agrupaciones de las categoras de modo que, en una aplicacin, una sola tabla pueda gestionar las categoras de todos los elementos implicados. El ser VARCHAR es por ser un tipo de datos ms "universal" que otros como numricos, set o e',
  descripcion varchar(255) NOT NULL COMMENT 'Un literal para denominar a la categora.',
  id_de_padre int(11) NOT NULL default '0' COMMENT 'el id de la categora padre de la que estamos tratando. Si no la hay (por ser esta una categora de nivel superior) se queda en 0.',
  PRIMARY KEY  (id_de_categoria)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

--
-- Volcar la base de datos para la tabla 'categorias'
--

INSERT INTO categorias (id_de_categoria, tipo_de_contenido, descripcion, id_de_padre) VALUES
(1, NULL, 'Informtica', 0),
(2, NULL, 'CPU''s', 1),
(3, NULL, 'Monitores', 1),
(4, NULL, 'Impresoras', 1),
(5, NULL, 'Perifricos', 1),
(6, NULL, 'Software', 1),
(7, NULL, 'De torre', 2),
(8, NULL, 'Mini torre', 2),
(9, NULL, 'Flat', 2),
(10, NULL, 'Micro channel', 2),
(11, NULL, 'TFT', 3),
(12, NULL, 'CRT', 3),
(13, NULL, 'Tctiles', 3),
(14, NULL, 'Matriciales', 4),
(15, NULL, 'De chorro de tinta', 4),
(16, NULL, 'Laser', 4),
(17, NULL, 'De tarjetas plsticas', 4),
(18, NULL, 'Teclados', 5),
(19, NULL, 'Lectores de tarjetas', 5),
(20, NULL, 'DVD externo', 5),
(21, NULL, 'Grabadora de Blue-Ray', 5),
(22, NULL, 'Con cable', 18),
(23, NULL, 'Inalmbricos', 18),
(24, NULL, 'Inalmbricos con ratn', 18),
(25, NULL, 'Flexibles', 18),
(26, NULL, 'Educativo', 6),
(27, NULL, 'Recreativo', 6),
(28, NULL, 'Profesional', 6),
(29, NULL, 'De redes', 6),
(30, NULL, 'Infantil', 26),
(31, NULL, 'Juvenil', 26),
(32, NULL, 'Universitario', 26),
(33, NULL, 'Juegos clsicos', 27),
(34, NULL, 'Juegos de arcade', 27),
(35, NULL, 'Blicos', 27),
(36, NULL, 'Plataformas', 27),
(37, NULL, 'Shooter', 27),
(38, NULL, 'Top ten', 27),
(39, NULL, 'Para arquitectura', 28),
(40, NULL, 'Para medicina', 28),
(41, NULL, 'Para derecho', 28),
(42, NULL, 'Programas de cocina', 28),
(43, NULL, 'De gestin de routers', 29),
(44, NULL, 'De seguridad', 29),
(45, NULL, 'Libros', 0),
(46, NULL, 'Novela', 45),
(47, NULL, 'Estudios primarios', 45),
(48, NULL, 'Estudios superiores', 45),
(49, NULL, 'Ciencia y tecnologa', 45),
(50, NULL, 'Informtica', 45),
(51, NULL, 'Infantil', 45),
(52, NULL, 'Juvenil', 45),
(53, NULL, 'Medicina', 45),
(54, NULL, 'Derecho', 45),
(55, NULL, 'Seguridad privada', 45),
(56, NULL, 'Histrica', 46),
(57, NULL, 'Aventuras', 46),
(58, NULL, 'Ertica', 46),
(59, NULL, 'Romntica', 46);
