<?php
/* ATENCION. PARA QUE ESTE SCRIPT FUNCIONE CORRECTAMENTE ES IMPRESCINDIBLE QUE LA DIRECTRIZ register_globals
SE ENCUENTRE DESACTIVADA. */

	session_start(); //Se inicia la sesin en esta pgina. Lo normal es que esta sentencia retome una sesin ya creada en el sitio.
	session_regenerate_id(); //Por seguridad, para evitar secuestros de sesin.

//=============================================================================================================================

/* A continuacin, se comprueba si est registrada la variable de sesin que contendr el total de registros.
Normalmente, las variables de sesin que utilice el sitio se registran en la pgina cero (usualmente, index.php).
Por lo tanto, si no est registrada la variable de sesin, es que el usuario ha accedido a esta pgina directamente, sin pasar
por la index. Es cuestin de criterio del webmaster si se lo permitimos o no. Si no queremos permitirlo, al encontrar que la variable no
est registrada redireccionaremos al usuario al index. Si queremos permitirle acceder directamente, al no aparecer la variable registrada
la registraremos aqu.
=======================================================================================================================
En este ejemplo se ha optado por la segunda alternativa, aunque en un sitio real yo soy partidario de que el usuario
deba acceder por la pgina cero.
=======================================================================================================================
Adems es necesario contar con una variable de sesin que establece cuantos registros se mostrarn en cada pgina.
Normalmente suelen ser 10, pero algunos sitios web dan al usuario opcin a cambiar esto.
Tambin aadimos una variable que contendr un criterio de seleccin para la consulta de la BBDD,
de modo que el usuario pueda elegir determinados criterios que le ofrezcamos. Cada criterio modificar
el contenido de esta variable, de modo que se mantendr el criterio como clasula WHERE en la consulta,
hasta que se indique lo contrario.
*/
	if (!session_is_registered("totalDeRegistros")){
		session_register("totalDeRegistros");
		session_register("registrosPorPagina");
		session_register("criterioDeSeleccion");
	}

	include ("includes/config_paginacion.php"); // fichero con los datos de configuracin.
// Dado que contiene el uso de algunas variables de sesin, es necesario que se incluya
// en el script DESPUS de session_start() y session_regenerate_id(), asi como despus
// de comprobar la existencia de dichas variables de sesin.

	include_once ("includes/enlaces.php"); //Las funciones que muestran los enlaces de navegacin.

//=============================================================================================================================

/* Se lee el nmero de registros y se asigna a la variable de sesin. Esta lectura se hace cada vez que se acceda a este
script, con independencia de que se haya hecho en un acceso inmediatamente anterior, ya que el nmero de registros puede variar
constantemente si, por ejemplo, el administrador esta aadiendo o eliminado fichas mediante un CMS.*/
	$consulta = "SELECT COUNT(*) FROM ".$tabla." WHERE ".$_SESSION["criterioDeSeleccion"].";";
	$hacerConsulta = mysql_query($consulta, $conexion);
	$_SESSION["totalDeRegistros"] = mysql_result($hacerConsulta, 0);
	@mysql_free_result ($hacerConasulta);

//=============================================================================================================================

/* A continuacin se ejecuta un bloque de sentencias que dependen de que haya registros en la tabla.
Por lo tanto, solo se ejecutan si el nmero de registros es mayor que cero.*/
	if($_SESSION["totalDeRegistros"] > 0){

/* En funcin del total de registros contabilizados y del nmero establecido de registros por pgina, se
determina el nmero de pginas que sern necesarias para mostrar todos los registros. */
		$numeroDePaginas = ceil($_SESSION["totalDeRegistros"] / $_SESSION["registrosPorPagina"]);

/* Se determina la pgina actual. Si ya se ha mandado este dato, significa que se ha pulsado un enlace de navegacin.
Si no, se coge la primera pgina por defecto. */
		if (isset($_POST["paginaActual"])){
			$paginaActual = $_POST["paginaActual"];
		} else {
			$paginaActual = 1;
		}

/* Se determina el registro inicial de los que se van a mostrar en la pgina. Si es la primera vez, ser el primer registro de la tabla.
Si ya se ha pulsado un enlace de navegacin, ser otro registro.*/
		$registroInicial = (($paginaActual - 1)*$_SESSION["registrosPorPagina"]);
	}
/* Aqu termina el bloque de sentencias que depende de la existencia de registros en la tabla. */

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Paginaci&oacute;n de resultados</title>
<link href="css/estilos_paginacion.css" rel="stylesheet" />
<script language="javascript" type="text/javascript">
/* La siguiente funcin cambia de pgina cuando es invocada desde los enlaces que se crean dinmicamente. */
	function mostrarPagina(destino){
		document.getElementById("paginaActual").value = destino;
		document.getElementById("formPaginacion").submit();
	}
/* La siguiente funcin se ejecutar si se pulsa el botn que aparece al no haber datos en la tabla.
Hay que establecer en cada caso el action del formulario.*/
	function retornar(){
		document.getElementById("formRetorno").submit();
	}
</script>
</head>
<body>

<!-- El siguiente formulario se emplea para volver al documeto web que haya llamado a este, si, por ejemplo,
nos encontramos con que la tabla de la BBDD no contiene datos. -->
<form action="<?php  echo $paginaDeRetorno; ?>" name="formRetorno" id="formRetorno" method="post">
	<input type="hidden" name="<?php echo session_name(); ?>" value="<?php echo session_id(); ?>" />
</form>

<?php
/* Si no hay registros, se debe proporcionar una salida para no forzar al script a intentar leer
una BBDD sin datos, lo que podra dar lugar a un error. */
	if($_SESSION["totalDeRegistros"] == 0){
		echo "La tabla no contiene datos.<br />";
	} else {

// Se ejecuta una consulta de PHP y se muestran los resultados.
		$numeroDeCampos = count($campos);
		$consulta = "SELECT ";
		for ($contadorDeCampos = 0; $contadorDeCampos<$numeroDeCampos; $contadorDeCampos ++){
			$consulta .= $campos[$contadorDeCampos];
			if (!(($contadorDeCampos+1) == $numeroDeCampos)) $consulta .= ", ";
		}
		$consulta .= " FROM ".$tabla." WHERE ".$_SESSION["criterioDeSeleccion"]." LIMIT ".$registroInicial.", ".$_SESSION["registrosPorPagina"].";";
		$hacerConsulta = mysql_query($consulta, $conexion);
		while ($fila = mysql_fetch_assoc($hacerConsulta)){
			for ($contadorDeCampos = 0; $contadorDeCampos<$numeroDeCampos; $contadorDeCampos ++){
				echo $fila[$campos[$contadorDeCampos]]."<br />";
			}
		}
		@mysql_free_result($hacerConsulta);

// El siguiente formulario maneja los datos ocultos necesarios para la navegacin.
		echo $formularioDePaginacion;

/* El siguiente fragmento se encarga de mostrar los enlaces bsicos de navegacin del paginado
(primera, anterior, siguiente y ltima). Estos se muestran como texto, en lugar de imgenes, y sin
ningn estilo, a fin de que sea genrico. Luego ya se adapta el diseo al de la pgina en cuestin.
Los enlaces de navegacin solo se muestran si el total de registros devuelto por la consulta es mayor
el nmero de registroas que se muestran en una nica pgina. */
		if ($_SESSION["totalDeRegistros"] > $_SESSION["registrosPorPagina"]){
			generarTablaDeEnlacesBasicos($paginaActual, $numeroDePaginas);
// Aqu acaban los enlaces bsicos de paginacin.

// Aqu empezan los enlaces para acceder directamente a las pginas de inoformacin por su nmero de pgina. 
			generarTablaDeEnlacesNumerados($enlacesPorNumeroDePagina, $numeroDePaginas, $paginaActual);
		}
	}
?>
	<input type="button" value="Volver" onClick="javascript:retornar();" />
</body>
</html>
