<html> 
<head>
<link type="text/css" rel="stylesheet" href="../css/estilos_de_calculadora.css" />
	<script language="JavaScript" type="text/javascript">
		var acumulado = 0;
		var nuevoNumero = false;
		var operacionPendiente = "";

		function inicializar(){
			document.getElementById("pantalla").value = "0";
		}

		function numeroPresionado(Numero) {
			if (nuevoNumero) {
				document.getElementById("pantalla").value = Numero;
				nuevoNumero = false;
			} else {
				if (document.getElementById("pantalla").value == "0"){
					document.getElementById("pantalla").value = Numero;
				} else {
					document.getElementById("pantalla").value += Numero;
				}
			}
		}

		function operacion(operacionElegida) {
			var pantalla = document.getElementById("pantalla").value;
			if (!(nuevoNumero && operacionPendiente != "=")) {
				nuevoNumero = true;
				if ('+' == operacionPendiente){
					acumulado += parseFloat(pantalla);
				} else if ( '-' == operacionPendiente ) {
					acumulado -= parseFloat(pantalla);
				} else if ( '/' == operacionPendiente ) {
					acumulado /= parseFloat(pantalla);
				} else if ( '*' == operacionPendiente ) {
					acumulado *= parseFloat(pantalla);
				} else {
					acumulado = parseFloat(pantalla);
				}
				document.getElementById("pantalla").value = acumulado;
				operacionPendiente = operacionElegida;
			}
		}

		function decimal() {
			var pantalla = document.getElementById("pantalla").value;
			if (nuevoNumero) {
				pantalla = "0.";
				nuevoNumero = false;
			} else {
				if (pantalla.indexOf(".") == -1) pantalla += ".";
			}
			document.getElementById("pantalla").value = pantalla;
		}

		function borrarEntrada() {
			document.getElementById("pantalla").value = "0";
			nuevoNumero = true;
		}

		function borrar() {
			acumulado = 0;
			operacionPendiente = "";
			borrarEntrada();
		}

		function negativo() {
			document.getElementById("pantalla").value = parseFloat(document.getElementById("pantalla").value) * -1;
		}

		function porcentaje() {
			document.getElementById("pantalla").value = (parseFloat(document.getElementById("pantalla").value) / 100) * parseFloat(acumulado);
			var pantalla = document.getElementById("pantalla").value;
			nuevoNumero = true;
			acumulado = parseFloat(pantalla);
			operacionPendiente = "=";
		}
	</script>
</head>
<body onLoad="javascript:inicializar();">
	<table class="cuerpoDeCalculadora" cellpadding="1" cellspacing="5">
		<tr>
			<td align="right" colspan="6"><input type="text" class="pantalla" id="pantalla" value="0" readonly="readonly" /></td>
		</tr>
		<tr>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(7);" value="7" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(8);" value="8" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(9);" value="9" /></td>
			<td align="center">&nbsp;</td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:negativo();" value="+/-" /></td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:porcentaje();" value="%" /></td>
		</tr>
		<tr>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(4);" value="4" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(5);" value="5" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(6);" value="6" /></td>
			<td align="center">&nbsp;</td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:operacion('+');" value="+" /></td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:operacion('-');" value="-" /></td>
		</tr>
		<tr>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(1);" value="1" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(2);" value="2" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(3);" value="3" /></td>
			<td align="center">&nbsp;</td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:operacion('*');" value="*" /></td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:operacion('/');" value="/" /></td>
		</tr>
		<tr>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:numeroPresionado(0);" value="0" /></td>
			<td align="center"><input type="button" class="botonesNegros" onClick="javascript:decimal();" value="." /></td>
			<td align="center"><input type="button" class="botonesAzules" onClick="javascript:operacion('=');" value="=" /></td>
			<td align="center">&nbsp;</td>
			<td align="center"><input type="button" class="botonesRojos" onClick="javascript:borrar();" value="C" /></td>
			<td align="center"><input type="button" class="botonesRojos" onClick="javascript:borrarEntrada();" value="CE" /></td>
		</tr>
	</table>
</body>
</html>

